import os

#nacitani materialu ze souburu na vstupu, vraci parametry materialu
def loadMaterial(material):
    for x in range(len(material)):
        material[x] = material[x].replace("\n", "").split(" ")
        while("" in material[x]):
            material[x].remove("")
        for y in material[x]:
            material[x][-1] = int(material[x][-1])
        rozmerKostky = material[x][1].split("X")
        material[x][1] = [int(rozmerKostky[0]), int(rozmerKostky[0])]
    return material

#otevreni a precteni souboru, vraci hodnotu rozmeru a typu veze, material
def loadFile(fileName):
    inputFile = open(fileName, "r")
    firstLine = inputFile.readline().replace("\n", "").split(" ")
    if("" in firstLine):
        firstLine.remove("")
    rozmery = [int(firstLine[0]), int(firstLine[1])]
    typ = firstLine[2]
    material = loadMaterial(inputFile.readlines())
    inputFile.close()
    return(rozmery, typ, material)

#rozpoznavani, zda je patro vyplnene
def isCorrect(floor):
    for x in floor:
        for y in x:
            if(y == ""):
                return False
    return True

#ma nalezt misto v patre pro polozeni 1 kostky na vstupu, vraci pozici, nebo hodnotu false, pokud nenalezne volne misto
def findPlace(kostka, floor):
    rozmerKostky = kostka[1]
    pozice = []
    able = True
    for a in range(len(floor)-rozmerKostky[0]):
        for b in range(a-rozmerKostky[1]):
            try:
                policko = floor[a][b]
                if(policko == ""):
                    for c in range(rozmerKostky[0]):
                        for d in range(rozmerKostky[1]):
                            if(able):
                                able = floor[a+c][b+d] == ""
                if(able):
                    return [a, b]
            except:
                pass

    return False

#navrhuje rozmisteni kosticek v patre, vraci design - technicky navrh pro tisk do souboru a floor - celkove rozmisteni kazdeho mista pro potencialni vykreslovani modelu
def buildFloor(rozmery, typ, material):
    floor = [[""]*rozmery[0]]*rozmery[1]
    design = []
    for a in range(len(material)):
        if(material[a][-1]>0):
            place = findPlace(material[a], floor)
            if(bool(place)):
                for x in range(place[0], place[0]+material[a][1][0]):
                    for y in range(place[1], place[1]+material[a][1][1]):
                        floor[x][y] = material[a][0:2]
                toDesign = place
                toDesign.append(material[a][:-1])
                design.append(toDesign)
    return floor, design

#samotny beh programnu, zavola nacteni, probehne navrh a zapise do souboru vystup
for file in os.listdir("/Z26"):
    if file.endswith(".in"):
        inputArguments = loadFile(file)
        rozmery = inputArguments[0]
        typ = inputArguments[1]
        material = inputArguments[2]
        material.reverse()

        outputFile = open(file.replace(".in", "")+".26", "w")
        outputFile.write(str(rozmery[0]) + " " + str(rozmery[1]) + " " + str(typ) + "\n")
        for x in range(20):
            y = buildFloor(rozmery, typ, material)
            for z in y[1]:
                outputFile.write(str(x+1) + ", " + str(z).replace("[", "").replace("]", "").replace("'", "") + "\n")
            outputFile.write("\n")
        outputFile.close()
